%Gibbs sampling for independent Normal-Gamma prior for beta and h
%load in the data set. 

clear

load riceIM.txt;
n=max(riceIM(:,1));
t=max(riceIM(:,2))-1989;
y=zeros(n,t);
x=zeros(16,n,t);
jmax=100;

etona = zeros(2,1);

%Transform and store data as inputs and outputs

kk=1;
for ii=1:n
    for jj=1:t
        if ii==riceIM(kk,1) && jj==riceIM(kk,2)-1989
            y(ii,jj)=log(riceIM(kk,3));
            if jj>=2
            x(jj-1,ii,jj)=1;
            end
            x(t,ii,jj)=log(riceIM(kk,4));
            x(t+1,ii,jj)=log(riceIM(kk,5));
            x(t+2,ii,jj)=log(riceIM(kk,6));
            x(t+3,ii,jj)=0.5*(log(riceIM(kk,4)))^2;
            x(t+4,ii,jj)=log(riceIM(kk,4))*log(riceIM(kk,5));
            x(t+5,ii,jj)=log(riceIM(kk,4))*log(riceIM(kk,6));
            x(t+6,ii,jj)=0.5*(log(riceIM(kk,5)))^2;
            x(t+7,ii,jj)=log(riceIM(kk,5))*log(riceIM(kk,6));
            x(t+8,ii,jj)=0.5*(log(riceIM(kk,6)))^2;
        end
        kk=kk+1;
    end 
end

%Now start Gibbs loop

%Specify the number of replications
%number of burnin replications
itsgibbs = 5;
s0=500;
%number of retained replications
s1=5000;

%Draw number of states from uniform or truncated Poisson prior
%If lambda=0, p(k)=1/k, if lambda=0, p(k)=unif
%Also store log-probabilites for A computation

lambda = 1;
lp = zeros(jmax,1);
pstates = zeros(jmax,1);

if lambda>0 
 normalizer = (poisscdf(jmax,lambda)-poisspdf(0,lambda));   
 for kk = 1:jmax
        pstates(kk) = poisspdf(kk,lambda)/normalizer;
        lp(kk) = log(pstates(kk));
        
 end
elseif lambda<0
    for kk = 1:jmax
        lp(kk) = -log(jmax);
        pstates(kk) = exp(lp(kk));
    end
else
    for kk = 1:jmax
        lp(kk) = log(1/kk);
        pstates(kk) = exp(lp(kk));
    end
end
    
temp = 0;
randstates = unifrnd(0,1);

for jj = 1:jmax
    temp = temp + pstates(jj);
    if randstates<temp
        j=jj;
        break
    end
end

%Specify a few things outside loop for truncated Normal draws
atrunc = 0*ones(j+7+j*size(x(8:16,:,:),1),1);
btrunc = ones(j+7+j*size(x(8:16,:,:),1),1);
latrunc=0*ones(j+7+j*size(x(8:16,:,:),1),1);
lbtrunc=0*ones(j+7+j*size(x(8:16,:,:),1),1);
latrunc(2:j,1)=1;

for ii=1:j
    latrunc(j+7+9*(ii-1)+1)=1;
    latrunc(j+7+9*(ii-1)+2)=1;
    latrunc(j+7+9*(ii-1)+3)=1;
end

dtrunc=eye(j+7+j*size(x(8:16,:,:),1));
if j>1
for ii=2:j
    dtrunc(ii,ii-1)=-1;
end
end
kstep=cumsum(ones(j*(1+size(x,1)),1));

%Birth rate of Poisson process and timeframe

birrate = 3;
timeframe = s0+s1;
   
%store all draws in the following matrices
%initialize them here

b_1=[];
b_2=[];
b_3=[];
b_4=[];
b_5=[];
b_6=[];
b_7=[];
b_8=[];
b_9=[];
b_10=[];
b_11=[];
b_12=[];
b_13=[];
b_14=[];
b_15=[];
h_1=[];
h_2=[];
h_3=[];
h_4=[];
h_5=[];
h_6=[];
h_7=[];
h_8=[];
h_9=[];
h_10=[];
h_11=[];
h_12=[];
h_13=[];
h_14=[];
h_15=[];
pi_1=[];
pi_2=[];
pi_3=[];
pi_4=[];
pi_5=[];
pi_6=[];
pi_7=[];
pi_8=[];
pi_9=[];
pi_10=[];
pi_11=[];
pi_12=[];
pi_13=[];
pi_14=[];
pi_15=[];
theta_1=[];
theta_2=[];
theta_3=[];
theta_4=[];
theta_5=[];
theta_6=[];
theta_7=[];
theta_8=[];
theta_9=[];
theta_10=[];
theta_11=[];
theta_12=[];
theta_13=[];
theta_14=[];
theta_15=[];
laminv_1=[];
laminv_2=[];
laminv_3=[];
laminv_4=[];
laminv_5=[];
laminv_6=[];
laminv_7=[];
laminv_8=[];
laminv_9=[];
laminv_10=[];
laminv_11=[];
laminv_12=[];
laminv_13=[];
laminv_14=[];
laminv_15=[];
u_1=[];
u_2=[];
u_3=[];
u_4=[];
u_5=[];
u_6=[];
u_7=[];
u_8=[];
u_9=[];
u_10=[];
u_11=[];
u_12=[];
u_13=[];
u_14=[];
u_15=[];
u_=[];

%Intercepts
delta0=zeros(j,1);

for ii = 1:j
    delta0(ii,1)=(2*(ii-1)+1)/6 - log(0.875);
end

%Hyperparameters for independent T.Normal-Gamma-Dirichlet-Exponential prior
%Hyperparameters for beta prior (T.Normal)

%Slopes
alpha0=zeros(16,1);
alpha0(1,1)=0.02;
alpha0(2,1)=0.04;
alpha0(3,1)=0.06;
alpha0(4,1)=0.08;
alpha0(5,1)=0.10;
alpha0(6,1)=0.12;
alpha0(7,1)=0.14;
alpha0(8,1)=0.5;
alpha0(9,1)=0.5;
alpha0(10,1)=0.5;
alpha0aux = alpha0(1:7);
alpha0aux2 = kron(ones(j,1),alpha0(8:16));
% Build beta0
b0=[delta0' alpha0aux' alpha0aux2']';
% Variances
capv0 = eye(j+7+9*j);
capv0(1:j,:)= 2.25*capv0(1:j,:);
capv0(j+1:j+7,:)= 0.15*capv0(j+1:j+7,:);
for jj=1:j
    capv0((jj-1)*9+j+7+1:(jj-1)*9+j+7+3,:)=6.5*capv0((jj-1)*9+j+7+1:(jj-1)*9+j+7+3,:);
    capv0((jj-1)*9+j+7+4:(jj-1)*9+j+7+9,:)=26*capv0((jj-1)*9+j+7+4:(jj-1)*9+j+7+9,:);
end
%Hyperparameters for state prob. prior (Dirichlet)
pi0=ones(j,1);
%Hyperparameters for Inefficiency prior (Exponential)
tau0=0.875;
%Hyperparameters for theta, run frequentist regression to get range of
%errors
kk =1;
xvert = zeros(n*t,16);
for ii = 1:n
    for tt = 1:t
        xvert(kk,:) = x(:,ii,tt);
        kk = kk+1;
    end
end
yvert = reshape(y,n*t,1);
[befreq,Sifreq,errors,Cofreq,logLfreq] = mvregress(xvert, yvert);
gtheta0= 0.2; %Need this to be smaller than s02inv
%Hyperparameters for precision prior (gamma)
v0 = 2;
htheta0= 100*gtheta0/(v0*(range(errors))^2);
thetadraw = gtheta0/htheta0;
%choose a starting value for h,pi,theta
hdraw = (v0/thetadraw)*ones(j,1);
 if min(hdraw)<0
        etona(3,1) = eye(2);
 end
pidraw = ones(j,1)/j;
%Choose starting value for beta
bdraw = b0;
%Draw set of starting values for d
ddraw = zeros(j,n,t);

quants = zeros(j,1);

for ii=1:j
    quants(ii) = ii/j;
end

quants = quantile(yvert,quants);

for kk=1:t
    for ii=1:n
        for jj=1:j-1
            if y(ii,kk)<quants(jj)
                ddraw(jj,ii,kk)=1;
                break
            end 
        end
        ddraw(j,ii,kk)= 1- sum(ddraw(1:j-1,ii,kk));
    end
end


%Draw from ui priors

% Now draw vector of ui's from exp(lam0) distr
udraw = -ones(n,1)*log(tau0);

%Creates cube z
z = zeros(size(ddraw,1)+size(x(1:7,:,:),1)+size(x(8:16,:,:),1)*size(ddraw,1),n,t);
   for ii = 1:n
     for tt = 1:t
        eta1 = vertcat(ddraw(:,ii,tt),x(1:7,ii,tt));
        eta2 = kron(ddraw(:,ii,tt),x(8:16,ii,tt));
        z(:,ii,tt) = vertcat(eta1(:,1),eta2(:,1));
     end
   end

numcomps = [];
timeit_ = [];
   
for vv = 0:timeframe
    timet = vv  
    
    timeit = tic;
    
    while timet<=vv+1
           
        logsum = 0;
        logsumctrained = zeros(j,1);
        pictrained = zeros(j);
        lik = zeros(n,t);
        likctr = zeros(j,n,t);
        loglik = zeros(n,t);
        loglikctr = zeros(j,n,t);
        
        if j==1
            
            pictrained = pidraw;
            dearate = 0;
            
        else
        
        for pp = 1:j
                pictrained(:,pp) = pidraw;
                pictrained(pp,pp)= 0;
                pictrained(:,pp) = pictrained(:,pp)/sum(pictrained(:,pp));
        end
 
    if min(hdraw)<0
        etona(3,1) = eye(2);
    end
        
            for  ii = 1:n
                for tt = 1:t
                   liksum = 0;
                   liksumctrained = zeros(j,1);
                   for jj = 1:j
                       liksum = liksum + max(0.01,pidraw(jj)*sqrt(hdraw(jj))*exp(-0.5*hdraw(jj)*(y(ii,tt)-bdraw(jj)-x(1:7,ii,tt)'*bdraw(j+1:j+7)-x(8:16,ii,tt)'*bdraw(j+7+(jj-1)*9+1:j+7+jj*9)+udraw(ii))^2)/(sqrt(2*pi)));
                       for pp = 1:j
                       liksumctrained(jj) = liksumctrained(jj) + max(0.01,pictrained(pp,jj)*sqrt(hdraw(pp))*exp(-0.5*hdraw(pp)*(y(ii,tt)-bdraw(pp)...
                            -x(1:7,ii,tt)'*bdraw(j+1:j+7)-x(8:16,ii,tt)'*bdraw(j+7+(pp-1)*9+1:j+7+pp*9)+udraw(ii))^2)/sqrt(2*pi));
                       end
                       logsumctrained(jj) = logsumctrained(jj)+log(liksumctrained(jj));
                       likctr(jj,ii,tt) = liksumctrained(jj)/sqrt(2*pi);
                       loglikctr(jj,ii,tt) = log(liksumctrained(jj));
                   end
                   lik(ii,tt) = liksum/sqrt(2*pi);
                   loglik (ii,tt) = log(liksum);
                   logsum = logsum+log(liksum);
                end
            end
            
            logratio = logsumctrained-logsum;
            
            for jj= 1:size(logratio,1)
                
            logratio(jj) = max(-20,min(20,logratio(jj)));
            
            end
            
            dearate = exp(logratio)*(birrate/lambda);
        
        end

        totdearate = sum(dearate);
        
        birordearate = birrate + totdearate;
        
        ufortime = unifrnd(0,1);
        
        timet = timet-log(ufortime)/birordearate;
        
        if j < jmax && unifrnd(0,1)<totdearate/birordearate
            death = 1;
        elseif j < jmax && unifrnd(0,1)>totdearate/birordearate
            death = 0;
        elseif j == jmax;
            death = 1;
        end
        
        % for debugging ONLY
        
        %death =1;
        
        if death == 1
            
           uwhichdea = unifrnd(0,1);
           j = j-1;
           temp = 0;
           for jj = 1:j+1
            temp = temp + dearate(jj)/totdearate;
            if uwhichdea<temp
            jremove=jj;
            break
            end
           end
           
           btemp=[];
           pitemp=[];
           htemp=[];
           
           for jj = 1:j+1
               if jj~=jremove
               btemp=[btemp;bdraw(jj)];
               pitemp=[pitemp;pidraw(jj)];
               htemp=[htemp;hdraw(jj)];
               end
           end
           
           pitemp = pitemp/sum(pitemp);
           btemp=[btemp;bdraw(j+1:j+7)];
           
           for jj = 1:j+1
               if jj~=jremove
               btemp=[btemp;bdraw(j+7+1+(jj-1)*9:j+7+jj*9)];
               end
           end
        
        bdraw = btemp;
        pidraw = pitemp;
        hdraw = htemp;
        
        if min(hdraw)<0
           etona(3,1) = eye(2);
        end
        
         
        %Generate smaller dimension b0, capv0, pi0
           
        %Intercepts
        delta0=zeros(j,1);

        for ii = 1:j
            delta0(ii,1)=(2*(ii-1)+1)/6 - log(0.875);
        end

        %Slopes
        alpha0aux3 = [alpha0aux;kron(ones(j,1),alpha0(8:16))];
       
        % Build beta0
        b0=[delta0' alpha0aux3']';
        
        % Variances
        capv0 = eye(j+7+9*j);
        capv0(1:j,:)= 2.25*capv0(1:j,:);
        capv0(j+1:j+7,:)= 0.15*capv0(j+1:j+7,:);
        for jj=1:j
            capv0((jj-1)*9+j+7+1:(jj-1)*9+j+7+3,:)=6.5*capv0((jj-1)*9+j+7+1:(jj-1)*9+j+7+3,:);
            capv0((jj-1)*9+j+7+4:(jj-1)*9+j+7+9,:)=26*capv0((jj-1)*9+j+7+4:(jj-1)*9+j+7+9,:);
        end
        
        %New pi0
        pi0= ones(j,1);
        
        % New ddraw
        
        dtemp=[];
        
        for jj = 1:j+1
           if jj~=jremove
             dtemp=[dtemp;ddraw(jj,:,:)];
           end
        end
        
        ddraw = dtemp;
        
        %Creates cube z
        z = zeros(size(ddraw,1)+size(x(1:7,:,:),1)+size(x(8:16,:,:),1)*size(ddraw,1),n,t);
           for ii = 1:n
             for tt = 1:t
                eta1 = vertcat(ddraw(:,ii,tt),x(1:7,ii,tt));
                eta2 = kron(ddraw(:,ii,tt),x(8:16,ii,tt));
                z(:,ii,tt) = vertcat(eta1(:,1),eta2(:,1));
             end
           end
        
        %Resize truncation parameters for betadraw
        atrunc = 0*ones(j+7+j*size(x(8:16,:,:),1),1);
        btrunc = ones(j+7+j*size(x(8:16,:,:),1),1);
        latrunc=0*ones(j+7+j*size(x(8:16,:,:),1),1);
        lbtrunc=0*ones(j+7+j*size(x(8:16,:,:),1),1);
        latrunc(2:j,1)=1;
        
        for ii=1:j
            latrunc(j+7+9*(ii-1)+1)=1;
            latrunc(j+7+9*(ii-1)+2)=1;
            latrunc(j+7+9*(ii-1)+3)=1;
        end
        
        dtrunc=eye(j+7+j*size(x(8:16,:,:),1));
        if j>1
         for ii=2:j
            dtrunc(ii,ii-1)=-1;
         end
        end
        kstep=cumsum(ones(j*(1+size(x,1)),1));
        
        else
            
        % Generate beta for the new component of the mixture   
        uwhichint = nearest(unifrnd(1,j));
        capv0new = [[capv0(uwhichint,uwhichint) capv0(uwhichint,j+7+1:j+7+9)] ;capv0(j+7+1:j+7+9,uwhichint) capv0(j+7+1:j+7+9,j+7+1:j+7+9)];
        bnew = [b0(uwhichint);b0(j+7+1:j+7+9)] + norm_rnd(capv0new);
        
        %Generate new h and pi for the new component of the mixture
        
        hnew = gamm_rnd(1,1,v0,thetadraw);
        
        if min(hnew)<0
        etona(3,1) = eye(2);
        end
        
        pinew = beta_rnd(1,1,j*1);
        
        indexnew = 1;
        
        for jj = 1:j
            if bnew(1)>bdraw(jj)
                indexnew = jj+1;
            end
        end
        
        btemp=[];
        pitemp=[];
        htemp=[];
        
      if indexnew ~= j+1
	    for jj = 1:j
           if jj~=indexnew
             btemp=[btemp;bdraw(jj)];
             pitemp=[pitemp;pidraw(jj)];
             htemp=[htemp;hdraw(jj)];
           else
             btemp=[btemp;bnew(1);bdraw(jj)];
             pitemp=[pitemp;pinew;pidraw(jj)];
             htemp=[htemp;hnew;hdraw(jj)];
           end
        end
      else
         btemp = [bdraw(1:j);bnew(1)];
         pitemp = [pidraw(1:j);pinew];
         htemp = [hdraw(1:j);hnew];
      end
      
      btemp = [btemp;bdraw(j+1:j+7)];
      
        if min(htemp)<0
           etona(3,1) = eye(2);
        end
           
           pitemp = pitemp/sum(pitemp);
        
      if indexnew ~= j+1
        for jj = 1:j
           if jj~=indexnew
             btemp=[btemp;bdraw(j+1+7+(jj-1)*9:j+7+jj*9)];
           else
             btemp=[btemp;bnew(2:10);bdraw(j+1+7+(jj-1)*9:j+7+jj*9)];
           end
        end
      else
         btemp = [btemp;bdraw(j+7+1:j+7+j*9);bnew(2:10)]; 
      end
        
        bdraw = btemp;
        pidraw = pitemp;
        hdraw = htemp;
        
        if min(hdraw)<0
           etona(3,1) = eye(2);
        end
        
        % New ddraw
        
        ddraw = zeros(j+1,n,t);

        quants = zeros(j+1,1);

        for ii=1:j+1
         quants(ii) = ii/(j+1);
        end

        quants = quantile(yvert,quants);

        for kk=1:t
            for ii=1:n
                for jj=1:j
                    if y(ii,kk)<quants(jj)
                     ddraw(jj,ii,kk)=1;
                        break
                    end 
                end
                ddraw(j+1,ii,kk)= 1- sum(ddraw(1:j,ii,kk));
            end
        end
        
        
        %Creates cube z
        z = zeros(size(ddraw,1)+size(x(1:7,:,:),1)+size(x(8:16,:,:),1)*size(ddraw,1),n,t);
        for ii = 1:n
            for tt = 1:t
                eta1 = vertcat(ddraw(:,ii,tt),x(1:7,ii,tt));
                eta2 = kron(ddraw(:,ii,tt),x(8:16,ii,tt));
                z(:,ii,tt) = vertcat(eta1(:,1),eta2(:,1));
            end
        end
        
        j = j+1;
        
        %Generate larger dimension b0, capv0, pi0
           
        %Intercepts
        delta0=zeros(j,1);
        for ii = 1:j
            delta0(ii,1)=(2*(ii-1)+1)/6 - log(0.875);
        end
        %Slopes
        alpha0aux4 = [alpha0aux;kron(ones(j,1),alpha0(8:16))];
        
        % Build beta0
        b0=[delta0' alpha0aux4']';
        
        % Variances
        capv0 = eye(j+7+9*j);
        capv0(1:j,:)= 2.25*capv0(1:j,:);
        capv0(j+1:j+7,:)= 0.15*capv0(j+1:j+7,:);
        for jj=1:j
            capv0((jj-1)*9+j+7+1:(jj-1)*9+j+7+3,:)=6.5*capv0((jj-1)*9+j+7+1:(jj-1)*9+j+7+3,:);
            capv0((jj-1)*9+j+7+4:(jj-1)*9+j+7+9,:)=26*capv0((jj-1)*9+j+7+4:(jj-1)*9+j+7+9,:);
        end
        
        
        %New pi0
        pi0= ones(j,1);


        %Resize truncation parameters for betadraw
        atrunc = 0*ones(j+7+j*size(x(8:16,:,:),1),1);
        btrunc = ones(j+7+j*size(x(8:16,:,:),1),1);
        latrunc=0*ones(j+7+j*size(x(8:16,:,:),1),1);
        lbtrunc=0*ones(j+7+j*size(x(8:16,:,:),1),1);
        latrunc(2:j,1)=1;
        
        for ii=1:j
            latrunc(j+7+9*(ii-1)+1)=1;
            latrunc(j+7+9*(ii-1)+2)=1;
            latrunc(j+7+9*(ii-1)+3)=1;
        end
        
        dtrunc=eye(j+7+j*size(x(8:16,:,:),1));
        if j>1
         for ii=2:j
            dtrunc(ii,ii-1)=-1;
         end
        end
        kstep=cumsum(ones(j*(1+size(x,1)),1));
        
        end
        
    end

for ll = 1:itsgibbs
        
   %draw dit's conditional on other parameters
    
    normterm1=zeros(j,n,t);
    multipar = zeros(j,n,t);
    mau2 = zeros(j,n,t);
    
    for ii=1:t
        for jj=1:n
            for pp=1:j
                normterm1(pp,jj,ii)= max(0.01,pidraw(pp)*normpdf(y(jj,ii),bdraw(pp,1)+x(1:7,jj,ii)'*bdraw(j+1:j+7)+z(j+7+9*(pp-1)+1:j+7+9*pp,jj,ii)'*bdraw(j+7+(pp-1)*9+1:j+7+pp*9)-udraw(jj)...
                    ,sqrt(inv(hdraw(pp)))));
            end
            multipar(:,jj,ii) = normterm1(:,jj,ii)./sum(normterm1(:,jj,ii));
            ddraw(:,jj,ii) = multi_rnd(multipar(:,jj,ii));
            if max(ddraw(:,jj,ii))==0
              etona(3,1) = eye(2);
            end
        end
    end
    
   % Draw theta given everything else
   
   gtheta1 = gtheta0 + j*v0;
   htheta1 = htheta0 + sum(hdraw);
   if min(hdraw)<0
        etona(3,1) = eye(2);
   end
   thetadraw = gamm_rnd(1,1,gtheta1,htheta1);
   
   if min(thetadraw)<0
        etona(3,1) = eye(2);
   end
    
   % draw from beta conditional on h,pi,d (First compute posterior pars.)
   % Compute capv1 and b1
   % Initializes auxsum1 and auxsum2 to zero.
   
   auxsum1=zeros(size(z,1));
   auxsum2=zeros(size(z,1),1);
   trunccounter = 0;
 
    for  ii = 1:t
        for jj = 1:n
             auxsum1 = auxsum1+(ddraw(:,jj,ii)'*hdraw)*z(:,jj,ii)*z(:,jj,ii)';
             auxsum2 = auxsum2+(ddraw(:,jj,ii)'*hdraw)*z(:,jj,ii)*(y(jj,ii)+udraw(jj));
        end
    end
    
    capv0inv=inv(capv0);
    capv1inv = capv0inv + auxsum1;
    capv1=inv(capv1inv);
    b1 = capv1*(capv0inv*b0 + auxsum2);
    
    % Draw beta considering intercept truncation
    
    bdraw = b1 + norm_rnd(capv1);
    while (normtruncation(bdraw,j) | monotonicity(bdraw,j,x))
    bdraw = b1 + norm_rnd(capv1);
    trunccounter = trunccounter + 1;
    if trunccounter > 30
       bdraw = tnorm_rndv3(size(b1,1),b1,capv1,atrunc,btrunc,latrunc,lbtrunc,dtrunc,kstep);
    end
    end
    
    %draw from h conditional on beta,pi and d
    v1 = sum(sum(ddraw,2),3)*0.5 + v0 ;
    auxsum3=zeros(j,1);
    for jj=1:n
        for ii=1:t
            auxsum3 = auxsum3 + ddraw(:,jj,ii)*(y(jj,ii)+udraw(jj)-z(:,jj,ii)'*bdraw)^2;
        end
    end
    s12 = thetadraw + auxsum3*0.5;
    
    if min(s12)<0
        etona(3,1) = eye(2);
    end
    
    for jj=1:j
    hdraw(jj,1) = gamm_rnd(1,1,v1(jj,1),s12(jj,1));
    end
    
   if min(hdraw)<0
        etona(3,1) = eye(2);
    end


    %draw from pi conditional on other parameters
    pi1=sum(sum(ddraw,2),3);
    pi1=pi1+pi0;
    pidraw = dirich_rnd(pi1);
    
   %Updates z
    
   for ii = 1:n
     for tt = 1:t
        eta1 = vertcat(ddraw(:,ii,tt),x(1:7,ii,tt));
        eta2 = kron(ddraw(:,ii,tt),x(8:16,ii,tt));
        z(:,ii,tt) = vertcat(eta1(:,1),eta2(:,1));
     end
   end

    % Draw laminvdraw conditional on other parameters
    
    gamm_par1=n+1;
    gamm_par2= (udraw'*ones(n,1) - log(tau0));
    laminvdraw = gamm_rnd(1,1,gamm_par1,gamm_par2);
    
    % Update parameters for muui and s2ui
   
   s2ui = zeros(n,1);
   muui = zeros(n,1);
   a= zeros(n,1);
   auxsum4 = 0;
   auxsum5 = 0;
    
   for ii=1:n
       auxsum4 = 0;
       auxsum5 = 0;
       for jj=1:t
           auxsum4 = ddraw(:,ii,jj)'*hdraw + auxsum4;
           auxsum5 = (ddraw(:,ii,jj)'*hdraw)*(z(:,ii,jj)'*bdraw-y(ii,jj)) + auxsum5;
       end
       s2ui(ii) = inv(auxsum4);
       muui(ii) = (auxsum5 - laminvdraw)/auxsum4;
   end

   %Draw ui
   
    muminus = -muui./sqrt(s2ui);
    muplus = (-log(0.5)-muui)./sqrt(s2ui);
   
    % Draw uis considering truncation using uniform rejection sampling
    
    for ii=1:n
        
        u1 = 1;
        rho = 0;
        
        while u1>=rho
        
        z1 = unifrnd(muminus(ii),muplus(ii));
        u1 = unifrnd(0,1);
        if 0>=muminus(ii) && muplus(ii)>=0
            rho = exp(-z1^2/2);
        elseif 0>muplus(ii)
            rho = exp((muplus(ii)^2-z1^2)/2);
        else
            rho = exp((muminus(ii)^2 - z1^2)/2);
        end
        end
        
        udraw(ii) = muui(ii)+z1*sqrt(s2ui(ii));
        
    end
   
if ll == itsgibbs && vv>s0
    
   numcomps =  [numcomps ; j];
   u_ = [u_ udraw];
    
   switch j
       
       case 1  
       b_1=[b_1 bdraw];
       h_1=[h_1 hdraw];
       pi_1=[pi_1 pidraw];
       theta_1=[theta_1 thetadraw];
       laminv_1=[laminv_1 laminvdraw];
       u_1 = [u_1 udraw];
       case 2
       b_2=[b_2 bdraw];
       h_2=[h_2 hdraw];
       pi_2=[pi_2 pidraw];
       theta_2=[theta_2 thetadraw];
       laminv_2=[laminv_2 laminvdraw];
       u_2 = [u_2 udraw];
       case 3
       b_3=[b_3 bdraw];
       h_3=[h_3 hdraw];
       pi_3=[pi_3 pidraw];
       theta_3=[theta_3 thetadraw];
       laminv_3=[laminv_3 laminvdraw];
       u_3 = [u_3 udraw];
       case 4
       b_4=[b_4 bdraw];
       h_4=[h_4 hdraw];
       pi_4=[pi_4 pidraw];
       theta_4=[theta_4 thetadraw];   
       laminv_4=[laminv_4 laminvdraw];
       u_4 = [u_4 udraw];       
       case 5
       b_5=[b_5 bdraw];
       h_5=[h_5 hdraw];
       pi_5=[pi_5 pidraw];
       theta_5=[theta_5 thetadraw];
       laminv_5=[laminv_5 laminvdraw];
       u_5 = [u_5 udraw];       
       case 6
       b_6=[b_6 bdraw];
       h_6=[h_6 hdraw];
       pi_6=[pi_6 pidraw];
       theta_6=[theta_6 thetadraw];
       laminv_6=[laminv_6 laminvdraw];
       u_6 = [u_6 udraw]; 
       case 7
       b_7=[b_7 bdraw];
       h_7=[h_7 hdraw];
       pi_7=[pi_7 pidraw];
       theta_7=[theta_7 thetadraw];  
       laminv_7=[laminv_7 laminvdraw];
       u_7 = [u_7 udraw];       
       case 8
       b_8=[b_8 bdraw];
       h_8=[h_8 hdraw];
       pi_8=[pi_8 pidraw];
       theta_8=[theta_8 thetadraw];  
       laminv_8=[laminv_8 laminvdraw];
       u_8 = [u_8 udraw];          
       case 9
       b_9=[b_9 bdraw];
       h_9=[h_9 hdraw];
       pi_9=[pi_9 pidraw];
       theta_9=[theta_9 thetadraw];
       laminv_9=[laminv_9 laminvdraw];
       u_9 = [u_9 udraw];          
       case 10
       b_10=[b_10 bdraw];
       h_10=[h_10 hdraw];
       pi_10=[pi_10 pidraw];
       theta_10=[theta_10 thetadraw];    
       laminv_10=[laminv_10 laminvdraw];
       u_10 = [u_10 udraw];        
       case 11
       b_11=[b_11 bdraw];
       h_11=[h_11 hdraw];
       pi_11=[pi_11 pidraw];
       theta_11=[theta_11 thetadraw];    
       laminv_11=[laminv_11 laminvdraw];
       u_11 = [u_11 udraw];     
       case 12
       b_12=[b_12 bdraw];
       h_12=[h_12 hdraw];
       pi_12=[pi_12 pidraw];
       theta_12=[theta_12 thetadraw];   
       laminv_12=[laminv_12 laminvdraw];
       u_12 = [u_12 udraw];            
       case 13
       b_13=[b_13 bdraw];
       h_13=[h_13 hdraw];
       pi_13=[pi_13 pidraw];
       theta_13=[theta_13 thetadraw]; 
       laminv_13=[laminv_13 laminvdraw];
       u_13 = [u_13 udraw];            
       case 14
       b_14=[b_14 bdraw];
       h_14=[h_14 hdraw];
       pi_14=[pi_14 pidraw];
       theta_14=[theta_14 thetadraw]; 
       laminv_14=[laminv_14 laminvdraw];
       u_14 = [u_14 udraw];          
       case 15
       b_15=[b_15 bdraw];
       h_15=[h_15 hdraw];
       pi_15=[pi_15 pidraw];
       theta_15=[theta_15 thetadraw];  
       laminv_15=[laminv_15 laminvdraw];
       u_15 = [u_15 udraw];           
   end
end
   
end

timeit_ = [timeit_; toc(timeit)];
end
  
componentbins = 1:max(numcomps);
ncount = histc(numcomps,componentbins);
maxcomp = componentbins(min(find(ncount==max(ncount))));

   switch maxcomp
       
       case 1  
       b=b_1;
       h=h_1;
       pi=pi_1;
       theta=theta_1;
       laminv = laminv_1;
       u = u_1;
       case 2
       b=b_2;
       h=h_2;
       pi=pi_2;
       theta=theta_2;
       laminv = laminv_2;
       u = u_2;       
       case 3
       b=b_3;
       h=h_3;
       pi=pi_3;
       theta=theta_3;
       laminv = laminv_3;
       u = u_3;       
       case 4
       b=b_4;
       h=h_4;
       pi=pi_4;
       theta=theta_4; 
       laminv = laminv_4;
       u = u_4;       
       case 5
       b=b_5;
       h=h_5;
       pi=pi_5;
       theta=theta_5;
       laminv = laminv_5;
       u = u_5;       
       case 6
       b=b_6;
       h=h_6;
       pi=pi_6;
       theta=theta_6;
       laminv = laminv_6;
       u = u_6;       
       case 7
       b=b_7;
       h=h_7;
       pi=pi_7;
       theta=theta_7; 
       laminv = laminv_7;
       u = u_7;       
       case 8
       b=b_8;
       h=h_8;
       pi=pi_8;
       theta=theta_8;
       laminv = laminv_8;
       u = u_8;       
       case 9
       b=b_9;
       h=h_9;
       pi=pi_9;
       theta=theta_9; 
       laminv = laminv_9;
       u = u_9;       
       case 10
       b=b_10;
       h=h_10;
       pi=pi_10;
       theta=theta_10;   
       laminv = laminv_10;
       u = u_10;      
       case 11
       b=b_11;
       h=h_11;
       pi=pi_11;
       theta=theta_11;   
       laminv = laminv_11;
       u = u_11;      
       case 12
       b=b_12;
       h=h_12;
       pi=pi_12;
       theta=theta_12;
       laminv = laminv_12;
       u = u_12;       
       case 13
       b=b_13;
       h=h_13;
       pi=pi_13;
       theta=theta_13; 
       laminv = laminv_13;
       u = u_13;      
       case 14
       b=b_14;
       h=h_14;
       pi=pi_14;
       theta=theta_14; 
       laminv = laminv_14;
       u = u_14;      
       case 15
       b=b_15;
       h=h_15;
       pi=pi_15;
       theta=theta_15; 
       laminv = laminv_15;
       u = u_15;       
   end

% Reporting results

figure('name','Intercepts and Time dummys');

for ii = 1:maxcomp+7
subplot(ceil((maxcomp+7)/4),4,ii)
plot(b(ii,:))
if ii<=maxcomp
xlabel(['Intercept ',num2str(ii)])
else
xlabel(['Time Dummy ',num2str(ii-maxcomp)])
end
end

figure('name','Slopes');

for ii = 1:(size(b,1)-maxcomp-7)

subplot(9,maxcomp,ii)
plot(b(maxcomp+7+ii,:))
xlabel(['Slope ',num2str(ii-floor(((ii-1)/9))*9),',', num2str(ceil(ii/9))])

end

figure('name','Component precision')
for ii = 1:size(h,1)

subplot(size(h,1),1,ii)
plot(h(ii,:))
xlabel(['Precision ',num2str(ii)])
end

figure('name','State probabilites')
for ii = 1:size(pi,1)

subplot(size(pi,1),1,ii)
plot(pi(ii,:))
xlabel(['Prob. of state ',num2str(ii)])

end

figure('name','Number of components distribution')

subplot(1,2,1)
plot(numcomps)
xlabel('Number of components in the mixture')
subplot(1,2,2)
bar(ncount/sum(ncount))
xlabel('Distribution for number of components')

meanu = mean(u,2);
meanTE = exp(-meanu);

means = mean([b;h;pi;theta],2);
stddevs = std([b;h;pi;theta],0,2);

GOF


    
    

